> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Create an agent in a FlowAI project

POST https://example.itential.io/agent-project-service/projects/{projId}/agents
Content-Type: application/json

Creates an Agent as a member of a FlowAI Project. Requires editor or owner GBAC role on the project.

Reference: https://docs.itential.com/itential-platform/6/api-reference/agent-project-service/create-agent

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Path parameters

- `projId` (string or string, required) — Project _id (UUID) or iid (integer).

### Body (application/json)

This endpoint expects an object.

- `name` (string, optional)
- `description` (string, optional)
- `instructions` (string, optional)
- `inputSchema` (object, optional)
  - `type` (any, required)
  - `additionalProperties` (any, required)
  - `required` (list of string, required)
  - `properties` (map from string to object, required)
- `provider` (object, optional)
  - `profile` (string, required)
  - `model` (string, required)
- `tools` (list of object, optional)
  - `referenceId` (string, required)
  - `decoratorId` (string, optional)
  - `lastKnownName` (string, optional)
- `operators` (list of string, optional)

## Response

### 200

The created Agent Definition

- `message` (string, required)
- `data` (object, required)
  - `_id` (string, required)
  - `name` (string, required)
  - `description` (string, required)
  - `instructions` (string, required)
  - `inputSchema` (object, required)
  - `created` (string, required)
  - `createdBy` (object, required)
    - `_id` (string, required)
    - `username` (string, required)
    - `provenance` (string, required)
  - `lastUpdated` (string, required)
  - `lastUpdatedBy` (object, required)
    - `_id` (string, required)
    - `username` (string, required)
    - `provenance` (string, required)
  - `operators` (list of object, required)
    - `_id` (string, required)
    - `name` (string, required)
    - `provenance` (string, required)
  - `namespace` (object, required)
    - `type` ("flowai_project", required)
    - `_id` (string, required)
    - `name` (string, required)
  - `authorized` (boolean, required)
  - `tools` (list of object or object, required)
    - object
      - `referenceId` (string, required)
      - `lastKnownName` (string, required)
      - `decoratorId` (string, optional)
    - object
      - `unauthorizedReferenceId` (string, required)
      - `lastKnownName` (string, required)
      - `decoratorId` (string, optional)
  - `provider` (object, optional, nullable)
    - `profile` (string, required)
    - `model` (string, required)
    - `lastKnownProfileName` (string, required)
    - `lastKnownModelName` (string, required)

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "message": "string",
  "data": {
    "_id": "string",
    "name": "string",
    "description": "string",
    "instructions": "string",
    "inputSchema": {},
    "created": "2024-01-15T09:30:00Z",
    "createdBy": {
      "_id": "string",
      "username": "string",
      "provenance": "string"
    },
    "lastUpdated": "2024-01-15T09:30:00Z",
    "lastUpdatedBy": {
      "_id": "string",
      "username": "string",
      "provenance": "string"
    },
    "operators": [
      {
        "_id": "string",
        "name": "string",
        "provenance": "string"
      }
    ],
    "namespace": {
      "type": "string",
      "_id": "string",
      "name": "string"
    },
    "authorized": true,
    "tools": [
      {
        "decoratorId": "string",
        "lastKnownName": "string",
        "referenceId": "string"
      }
    ],
    "provider": null
  }
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/agent-project-service/projects/string/agents"

payload = {}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/agent-project-service/projects/string/agents';
const options = {method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{}'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/agent-project-service/projects/string/agents"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/agent-project-service/projects/string/agents")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://example.itential.io/agent-project-service/projects/string/agents")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://example.itential.io/agent-project-service/projects/string/agents', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/agent-project-service/projects/string/agents");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/agent-project-service/projects/string/agents")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```